﻿using ArtOfTest.Common.UnitTesting;
using ArtOfTest.WebAii.Core;
using ArtOfTest.WebAii.Silverlight;
using TechTalk.SpecFlow;
using Telerik.WebAii.Controls.Xaml.Wpf;

namespace Specflow_HelloWorld
{
    [Binding]
    public class StepDefinitions
    {
        public string webPath = @"http://demos.telerik.com/silverlight/#Calculator/FirstLook";

        public RadCalculator calc { get; set; }

        [Given(@"clean RadCalculatror")]
        public void GivenRadCalculatror()
        {
            Manager.Current.ActiveBrowser.NavigateTo(webPath);
            Manager.Current.ActiveBrowser.WaitUntilReady();
            var TestApp = Manager.Current.ActiveBrowser.SilverlightApps()[0];
            calc = TestApp.Find.ByType<RadCalculator>();
            calc.ClearButton.User.Click();
            calc.Refresh();
        }

        [When(@"I enter (.*)")]
        public void WhenIEnter(int number)
        {
            switch (number)
            {
                case 0:
                    calc.Input0Button.User.Click();
                    break;
                case 1:
                    calc.Input1Button.User.Click();
                    break;
                case 2:
                    calc.Input2Button.User.Click();
                    break;
                case 3:
                    calc.Input3Button.User.Click();
                    break;
                case 4:
                    calc.Input4Button.User.Click();
                    break;
                case 5:
                    calc.Input5Button.User.Click();
                    break;
                case 6:
                    calc.Input6Button.User.Click();
                    break;
                case 7:
                    calc.Input7Button.User.Click();
                    break;
                case 8:
                    calc.Input8Button.User.Click();
                    break;
                case 9:
                    calc.Input9Button.User.Click();
                    break;
            }
        }

        [When(@"I press AddButton")]
        public void WhenIPressAddButton()
        {
            calc.AddButton.User.Click();
        }

        [When(@"I press SubtractButton")]
        public void WhenIPressSubtractButton()
        {
            calc.SubtractButton.User.Click();
        }

        [When(@"I press MultiplyButton")]
        public void WhenIPressMultiplyButton()
        {
            calc.MultiplyButton.User.Click();
        }

        [When(@"I press DivideButton")]
        public void WhenIPressDivideButton()
        {
            calc.DivideButton.User.Click();
        }

        [Then(@"the result should be (.*)")]
        public void ThenTheResultShouldBe(string result)
        {
            calc.Refresh();        
            Assert.AreEqual<string>(result, calc.DisplayText);
        }

        [When(@"I press equal")]
        public void WhenIPressEqual()
        {
            calc.EqualButton.User.Click();
        }

        [Then(@"RadCalculatror sum correctly")]
        public void ThenRadCalculatrorSumCorrectly(Table table)
        {
            foreach(var row in table.Rows)
            {
                var item1 = int.Parse(row["Input1"]);
                var item2 = int.Parse(row["Input2"]);

                WhenIEnter(item1);
                calc.AddButton.User.Click();
                WhenIEnter(item2);
                calc.EqualButton.User.Click();
                ThenTheResultShouldBe(row["Result"]);
            }
        }
    }
}
